/*	$AoiMoe: event.h,v 1.9 2001/08/08 19:28:12 tshiozak Exp $	*/

/*
 * Copyright (c) 2001 Takuya SHIOZAKI <AoiMoe@imou.to>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */


#ifndef AMUSE_EVENT_H_
#define AMUSE_EVENT_H_


#define AM_DEF_RECEIVER(name_, proto_, args_) \
class name_##Notifier; \
class name_##Receiver { \
public: \
	virtual void callback proto_ = 0; \
	virtual ~name_##Receiver() { } \
	class name_##Refer_ { \
		AMList<name_##Receiver>::Iterator iter_; \
	public: \
		name_##Refer_() { } \
		~name_##Refer_() { iter_.remove(); } \
		AMList<name_##Receiver>::Iterator &operator * () \
		{ \
			return iter_; \
		} \
		AMList<name_##Receiver>::Iterator *operator -> () \
		{ \
			return &iter_; \
		} \
		void clear() \
		{ \
			iter_ = AMList<name_##Receiver>::Iterator(); \
		} \
	}; \
	name_##Refer_ iter##name_##Receiver_; \
	void *clientDataOf##name_##Receiver_; \
protected: \
	name_##Receiver() : clientDataOf##name_##Receiver_(0) { } \
}

#define AM_DEF_NOTIFIER(name_, proto_, args_) \
class name_##Notifier { \
protected: \
	typedef name_##Receiver R_; \
	typedef AMList<R_> L_; \
	L_ *list_; \
	void notify_base proto_ \
	{ \
		L_ *old; \
		R_ *top; \
		old = list_; list_ = new L_; \
		while ((top=old->remove_head())) { \
			top->iter##name_##Receiver_.clear(); \
			top->callback args_; \
		} \
		delete old; \
	} \
	void connect_base(R_ *rv) \
	{ \
		list_->insert_tail(rv); \
		*rv->iter##name_##Receiver_ = list_->last(); \
	} \
	void disconnect_base(R_ *rv) \
	{ \
		rv->iter##name_##Receiver_->remove(); \
	} \
	void destruct_base() { delete list_; } \
	name_##Notifier() : list_(new L_) { } \
public: \
	virtual ~name_##Notifier() { destruct_base(); } \
	virtual void notify proto_ = 0; \
	virtual void connect(R_ *rv) = 0; \
	virtual void disconnect(R_ *rv) = 0; \
	bool isempty() const { return list_->isempty(); } \
}

#define AM_DEF_SIMPLE_NOTIFIER(name_, proto_, args_) \
AM_DEF_NOTIFIER(name_, proto_, args_); \
class Simple##name_##Notifier : public name_##Notifier { \
public: \
	virtual void notify proto_ { notify_base args_; } \
	virtual void connect(R_ *rv) { connect_base(rv); } \
	virtual void disconnect(R_ *rv) { disconnect_base(rv); } \
}

#define AM_DEF_SIMPLE_RECEIVERNOTIFIER(name_, proto_, args_) \
AM_DEF_RECEIVER(name_, proto_, args_); \
AM_DEF_SIMPLE_NOTIFIER(name_, proto_, args_)


#endif
