/*	$AoiMoe: rect.cc,v 1.4 2001/08/01 20:03:24 tshiozak Exp $	*/

/*
 * Copyright (c) 2001 Takuya SHIOZAKI <AoiMoe@imou.to>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */


#include "types.h"

Rect const &
Rect::operator &= (Rect const &src)
{
	if (this->x()<src.x()) {
		this->w(this->w() - (src.x()-this->x()));
		this->x(src.x());
	}
	if (this->y()<src.y()) {
		this->h(this->h() - (src.y()-this->y()));
		this->y(src.y());
	}
	if (this->x()+this->w()>src.x()+src.w()) {
		this->w(this->w() -
			((this->x()+this->w()) - (src.x()+src.w())));
	}
	if (this->y()+this->h()>src.y()+src.h()) {
		this->h(this->h() -
			((this->y()+this->h()) - (src.y()+src.h())));
	}
	return *this;
}

Rect const &
Rect::operator |= (Rect const &src)
{
	if (!*this) {
		*this = src;
	} else {
		if (this->x()>src.x()) {
			this->w(this->w() + this->x()-src.x());
			this->x(src.x());
		}
		if (this->y()>src.y()) {
			this->h(this->h() + this->y()-src.y());
			this->y(src.y());
		}
		if (this->w()<src.w())
			this->w(src.w());
		if (this->h()<src.h())
			this->h(src.h());
	}
	return *this;
}
