/*	$AoiMoe: servant.h,v 1.9 2001/08/01 20:03:24 tshiozak Exp $	*/

/*
 * Copyright (c) 2001 Takuya SHIOZAKI <AoiMoe@imou.to>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */


#ifndef AMUSE_SERVANT_H_
#define AMUSE_SERVANT_H_

AM_DEF_SIMPLE_RECEIVERNOTIFIER(ServantStart,
			       (ServantStartNotifier const &), (*this));
AM_DEF_SIMPLE_RECEIVERNOTIFIER(ServantIdle,
			       (ServantIdleNotifier const &), (*this));
AM_DEF_SIMPLE_RECEIVERNOTIFIER(AMButton,
			       (AMButtonNotifier const &, Pos const &pos),
			       (*this, pos));
AM_DEF_SIMPLE_RECEIVERNOTIFIER(AMMotion,
			       (AMMotionNotifier const &, Pos const &pos),
			       (*this, pos));

class Servant {
protected:
	SimpleServantStartNotifier startNotifier_;
	mutable Canvas *canvas_;
	mutable TimeOutNotifier *timeout_;
public:
	Servant() { }
	virtual ~Servant() { }
	ServantStartNotifier &start_notifier() { return startNotifier_; }
	Canvas const &canvas() const { return *canvas_; }
	TimeOutNotifier &timeout_notifier() const { return *timeout_; }
	//
	virtual int mainloop() const = 0;
	virtual ServantIdleNotifier &idle_notifier() const = 0;
	virtual AMButtonNotifier &button_notifier() const = 0;
	virtual AMMotionNotifier &motion_notifier() const = 0;
	virtual Pos get_cursor_pos() const = 0;
	virtual Tick current_tick() const = 0;
};

namespace ServantFactory {
	Servant *create(int *, char **, WH const &);
}

#endif
