/*	$AoiMoe: vinfo_p.h,v 1.5 2001/08/01 20:39:42 tshiozak Exp $	*/

/*
 * Copyright (c) 2001 Takuya SHIOZAKI <AoiMoe@imou.to>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */


#ifndef AMUSE_VINFO_P_H_
#define AMUSE_VINFO_P_H_

inline int VisualInfo::get_lsb_addr(uint32_t v)
{
	int ret=0;
	while ((v&1)==0) {
		ret++;
		v>>=1;
	} 
	return ret;
}
inline int VisualInfo::get_norm(uint32_t v)
{
	int ret=0;
	while ((v&1)==0)
		v>>=1;
	while ((v&1)!=0) {
		ret++;
		v>>=1;
	}
	return ret;
}

inline void VisualInfo::calc_shifts(PixelShiftsRec *s, uint32_t mask)
{
	AMUSE_ASSERT((!!mask));
	s->lshift = get_lsb_addr(mask);
	s->rshift = 8-get_norm(mask);
}


inline void
put8(void *ptr, uint8_t v)
{
	((uint8_t *)ptr)[0] = v;
}

inline void
put16be(void *ptr, uint16_t v)
{
	((uint8_t *)ptr)[1] = v;
	((uint8_t *)ptr)[0] = v>>8;
}

inline void
put16le(void *ptr, uint16_t v)
{
	((uint8_t *)ptr)[0] = v;
	((uint8_t *)ptr)[1] = v>>8;
}

inline void
put24be(void *ptr, uint32_t v)
{
	((uint8_t *)ptr)[2] = v;
	((uint8_t *)ptr)[1] = v>>8;
	((uint8_t *)ptr)[0] = v>>16;
}

inline void
put24le(void *ptr, uint32_t v)
{
	((uint8_t *)ptr)[0] = v;
	((uint8_t *)ptr)[1] = v>>8;
	((uint8_t *)ptr)[2] = v>>16;
}


inline void
put32be(void *ptr, uint32_t v)
{
	((uint8_t *)ptr)[3] = v;
	((uint8_t *)ptr)[2] = v>>8;
	((uint8_t *)ptr)[1] = v>>16;
	((uint8_t *)ptr)[0] = v>>24;
}

inline void
put32le(void *ptr, uint32_t v)
{
	((uint8_t *)ptr)[0] = v;
	((uint8_t *)ptr)[1] = v>>8;
	((uint8_t *)ptr)[2] = v>>16;
	((uint8_t *)ptr)[3] = v>>24;
}


#endif
