/*	$AoiMoe: sss_ini.h,v 1.2 2001/08/08 19:40:31 tshiozak Exp $	*/

/*
 * Copyright (c) 2001 Takuya SHIOZAKI <AoiMoe@imou.to>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */


#ifndef SSS_INI_H_
#define SSS_INI_H_


#pragma interface

class SSSIniElement {
public:
	virtual ~SSSIniElement() { }
	virtual bool operator == (char const *) const = 0;
	virtual char const *name() const = 0;
	virtual char const *val() const = 0;
	virtual void val(char const *) const = 0;
};

class SSSIniSection {
public:
	virtual ~SSSIniSection() { }
	virtual bool operator == (char const *) const = 0;
	virtual char const *lookup(char const *) const = 0;
	virtual void add(char const *, char const *) const = 0;
	virtual int num_elements() const = 0;
	virtual AMList<SSSIniElement> elements() const = 0;
};

class SSSIni {
public:
	virtual ~SSSIni() { }
	virtual SSSIniSection const *lookup(char const *) const = 0;
	virtual SSSIniSection const *add(char const *) const = 0;
	virtual int num_sections() const = 0;
	virtual AMList<SSSIniSection> sections() const = 0;
};

namespace SSSIniFactory {
	SSSIni *create(char const *);
}


#endif
